<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/regex-1.6.0/src/pikevm.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>pikevm.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../regex/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../regex/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../regex/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
</pre><pre class="rust"><code><span class="comment">// This module implements the Pike VM. That is, it guarantees linear time</span>
<span class="comment">// search of a regex on any text with memory use proportional to the size of</span>
<span class="comment">// the regex.</span>
<span class="comment">//</span>
<span class="comment">// It is equal in power to the backtracking engine in this crate, except the</span>
<span class="comment">// backtracking engine is typically faster on small regexes/texts at the</span>
<span class="comment">// expense of a bigger memory footprint.</span>
<span class="comment">//</span>
<span class="comment">// It can do more than the DFA can (specifically, record capture locations</span>
<span class="comment">// and execute Unicode word boundary assertions), but at a slower speed.</span>
<span class="comment">// Specifically, the Pike VM executes a DFA implicitly by repeatedly expanding</span>
<span class="comment">// epsilon transitions. That is, the Pike VM engine can be in multiple states</span>
<span class="comment">// at once where as the DFA is only ever in one state at a time.</span>
<span class="comment">//</span>
<span class="comment">// Therefore, the Pike VM is generally treated as the fallback when the other</span>
<span class="comment">// matching engines either aren&#39;t feasible to run or are insufficient.</span>

<span class="kw">use</span> <span class="ident">std::mem</span>;

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::exec::ProgramCache</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::input</span>::{<span class="ident">Input</span>, <span class="ident">InputAt</span>};
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::prog</span>::{<span class="ident">InstPtr</span>, <span class="ident">Program</span>};
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::re_trait::Slot</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::sparse::SparseSet</span>;

<span class="doccomment">/// An NFA simulation matching engine.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Fsm</span><span class="op">&lt;</span><span class="lifetime">&#39;r</span>, <span class="ident">I</span><span class="op">&gt;</span> {
    <span class="doccomment">/// The sequence of opcodes (among other things) that is actually executed.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The program may be byte oriented or Unicode codepoint oriented.</span>
    <span class="ident">prog</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;r</span> <span class="ident">Program</span>,
    <span class="doccomment">/// An explicit stack used for following epsilon transitions. (This is</span>
    <span class="doccomment">/// borrowed from the cache.)</span>
    <span class="ident">stack</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;r</span> <span class="kw-2">mut</span> <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">FollowEpsilon</span><span class="op">&gt;</span>,
    <span class="doccomment">/// The input to search.</span>
    <span class="ident">input</span>: <span class="ident">I</span>,
}

<span class="doccomment">/// A cached allocation that can be reused on each execution.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Cache</span> {
    <span class="doccomment">/// A pair of ordered sets for tracking NFA states.</span>
    <span class="ident">clist</span>: <span class="ident">Threads</span>,
    <span class="ident">nlist</span>: <span class="ident">Threads</span>,
    <span class="doccomment">/// An explicit stack used for following epsilon transitions.</span>
    <span class="ident">stack</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">FollowEpsilon</span><span class="op">&gt;</span>,
}

<span class="doccomment">/// An ordered set of NFA states and their captures.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">struct</span> <span class="ident">Threads</span> {
    <span class="doccomment">/// An ordered set of opcodes (each opcode is an NFA state).</span>
    <span class="ident">set</span>: <span class="ident">SparseSet</span>,
    <span class="doccomment">/// Captures for every NFA state.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// It is stored in row-major order, where the columns are the capture</span>
    <span class="doccomment">/// slots and the rows are the states.</span>
    <span class="ident">caps</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Slot</span><span class="op">&gt;</span>,
    <span class="doccomment">/// The number of capture slots stored per thread. (Every capture has</span>
    <span class="doccomment">/// two slots.)</span>
    <span class="ident">slots_per_thread</span>: <span class="ident">usize</span>,
}

<span class="doccomment">/// A representation of an explicit stack frame when following epsilon</span>
<span class="doccomment">/// transitions. This is used to avoid recursion.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">enum</span> <span class="ident">FollowEpsilon</span> {
    <span class="doccomment">/// Follow transitions at the given instruction pointer.</span>
    <span class="ident">IP</span>(<span class="ident">InstPtr</span>),
    <span class="doccomment">/// Restore the capture slot with the given position in the input.</span>
    <span class="ident">Capture</span> { <span class="ident">slot</span>: <span class="ident">usize</span>, <span class="ident">pos</span>: <span class="ident">Slot</span> },
}

<span class="kw">impl</span> <span class="ident">Cache</span> {
    <span class="doccomment">/// Create a new allocation used by the NFA machine to record execution</span>
    <span class="doccomment">/// and captures.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">_prog</span>: <span class="kw-2">&amp;</span><span class="ident">Program</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">Cache</span> { <span class="ident">clist</span>: <span class="ident">Threads::new</span>(), <span class="ident">nlist</span>: <span class="ident">Threads::new</span>(), <span class="ident">stack</span>: <span class="macro">vec!</span>[] }
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;r</span>, <span class="ident">I</span>: <span class="ident">Input</span><span class="op">&gt;</span> <span class="ident">Fsm</span><span class="op">&lt;</span><span class="lifetime">&#39;r</span>, <span class="ident">I</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Execute the NFA matching engine.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If there&#39;s a match, `exec` returns `true` and populates the given</span>
    <span class="doccomment">/// captures accordingly.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">exec</span>(
        <span class="ident">prog</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;r</span> <span class="ident">Program</span>,
        <span class="ident">cache</span>: <span class="kw-2">&amp;</span><span class="ident">ProgramCache</span>,
        <span class="ident">matches</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">bool</span>],
        <span class="ident">slots</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">Slot</span>],
        <span class="ident">quit_after_match</span>: <span class="ident">bool</span>,
        <span class="ident">input</span>: <span class="ident">I</span>,
        <span class="ident">start</span>: <span class="ident">usize</span>,
        <span class="ident">end</span>: <span class="ident">usize</span>,
    ) -&gt; <span class="ident">bool</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">cache</span> <span class="op">=</span> <span class="ident">cache</span>.<span class="ident">borrow_mut</span>();
        <span class="kw">let</span> <span class="ident">cache</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">cache</span>.<span class="ident">pikevm</span>;
        <span class="ident">cache</span>.<span class="ident">clist</span>.<span class="ident">resize</span>(<span class="ident">prog</span>.<span class="ident">len</span>(), <span class="ident">prog</span>.<span class="ident">captures</span>.<span class="ident">len</span>());
        <span class="ident">cache</span>.<span class="ident">nlist</span>.<span class="ident">resize</span>(<span class="ident">prog</span>.<span class="ident">len</span>(), <span class="ident">prog</span>.<span class="ident">captures</span>.<span class="ident">len</span>());
        <span class="kw">let</span> <span class="ident">at</span> <span class="op">=</span> <span class="ident">input</span>.<span class="ident">at</span>(<span class="ident">start</span>);
        <span class="ident">Fsm</span> { <span class="ident">prog</span>, <span class="ident">stack</span>: <span class="kw-2">&amp;mut</span> <span class="ident">cache</span>.<span class="ident">stack</span>, <span class="ident">input</span> }.<span class="ident">exec_</span>(
            <span class="kw-2">&amp;mut</span> <span class="ident">cache</span>.<span class="ident">clist</span>,
            <span class="kw-2">&amp;mut</span> <span class="ident">cache</span>.<span class="ident">nlist</span>,
            <span class="ident">matches</span>,
            <span class="ident">slots</span>,
            <span class="ident">quit_after_match</span>,
            <span class="ident">at</span>,
            <span class="ident">end</span>,
        )
    }

    <span class="kw">fn</span> <span class="ident">exec_</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="kw-2">mut</span> <span class="ident">clist</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Threads</span>,
        <span class="kw-2">mut</span> <span class="ident">nlist</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Threads</span>,
        <span class="ident">matches</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">bool</span>],
        <span class="ident">slots</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">Slot</span>],
        <span class="ident">quit_after_match</span>: <span class="ident">bool</span>,
        <span class="kw-2">mut</span> <span class="ident">at</span>: <span class="ident">InputAt</span>,
        <span class="ident">end</span>: <span class="ident">usize</span>,
    ) -&gt; <span class="ident">bool</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">matched</span> <span class="op">=</span> <span class="bool-val">false</span>;
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">all_matched</span> <span class="op">=</span> <span class="bool-val">false</span>;
        <span class="ident">clist</span>.<span class="ident">set</span>.<span class="ident">clear</span>();
        <span class="ident">nlist</span>.<span class="ident">set</span>.<span class="ident">clear</span>();
        <span class="lifetime">&#39;LOOP</span>: <span class="kw">loop</span> {
            <span class="kw">if</span> <span class="ident">clist</span>.<span class="ident">set</span>.<span class="ident">is_empty</span>() {
                <span class="comment">// Three ways to bail out when our current set of threads is</span>
                <span class="comment">// empty.</span>
                <span class="comment">//</span>
                <span class="comment">// 1. We have a match---so we&#39;re done exploring any possible</span>
                <span class="comment">//    alternatives. Time to quit. (We can&#39;t do this if we&#39;re</span>
                <span class="comment">//    looking for matches for multiple regexes, unless we know</span>
                <span class="comment">//    they all matched.)</span>
                <span class="comment">//</span>
                <span class="comment">// 2. If the expression starts with a &#39;^&#39; we can terminate as</span>
                <span class="comment">//    soon as the last thread dies.</span>
                <span class="kw">if</span> (<span class="ident">matched</span> <span class="op">&amp;&amp;</span> <span class="ident">matches</span>.<span class="ident">len</span>() <span class="op">&lt;</span><span class="op">=</span> <span class="number">1</span>)
                    <span class="op">|</span><span class="op">|</span> <span class="ident">all_matched</span>
                    <span class="op">|</span><span class="op">|</span> (<span class="op">!</span><span class="ident">at</span>.<span class="ident">is_start</span>() <span class="op">&amp;&amp;</span> <span class="self">self</span>.<span class="ident">prog</span>.<span class="ident">is_anchored_start</span>)
                {
                    <span class="kw">break</span>;
                }

                <span class="comment">// 3. If there&#39;s a literal prefix for the program, try to</span>
                <span class="comment">//    jump ahead quickly. If it can&#39;t be found, then we can</span>
                <span class="comment">//    bail out early.</span>
                <span class="kw">if</span> <span class="op">!</span><span class="self">self</span>.<span class="ident">prog</span>.<span class="ident">prefixes</span>.<span class="ident">is_empty</span>() {
                    <span class="ident">at</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">input</span>.<span class="ident">prefix_at</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">prog</span>.<span class="ident">prefixes</span>, <span class="ident">at</span>) {
                        <span class="prelude-val">None</span> =&gt; <span class="kw">break</span>,
                        <span class="prelude-val">Some</span>(<span class="ident">at</span>) =&gt; <span class="ident">at</span>,
                    };
                }
            }

            <span class="comment">// This simulates a preceding &#39;.*?&#39; for every regex by adding</span>
            <span class="comment">// a state starting at the current position in the input for the</span>
            <span class="comment">// beginning of the program only if we don&#39;t already have a match.</span>
            <span class="kw">if</span> <span class="ident">clist</span>.<span class="ident">set</span>.<span class="ident">is_empty</span>()
                <span class="op">|</span><span class="op">|</span> (<span class="op">!</span><span class="self">self</span>.<span class="ident">prog</span>.<span class="ident">is_anchored_start</span> <span class="op">&amp;&amp;</span> <span class="op">!</span><span class="ident">all_matched</span>)
            {
                <span class="self">self</span>.<span class="ident">add</span>(<span class="kw-2">&amp;mut</span> <span class="ident">clist</span>, <span class="ident">slots</span>, <span class="number">0</span>, <span class="ident">at</span>);
            }
            <span class="comment">// The previous call to &quot;add&quot; actually inspects the position just</span>
            <span class="comment">// before the current character. For stepping through the machine,</span>
            <span class="comment">// we can to look at the current character, so we advance the</span>
            <span class="comment">// input.</span>
            <span class="kw">let</span> <span class="ident">at_next</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">input</span>.<span class="ident">at</span>(<span class="ident">at</span>.<span class="ident">next_pos</span>());
            <span class="kw">for</span> <span class="ident">i</span> <span class="kw">in</span> <span class="number">0</span>..<span class="ident">clist</span>.<span class="ident">set</span>.<span class="ident">len</span>() {
                <span class="kw">let</span> <span class="ident">ip</span> <span class="op">=</span> <span class="ident">clist</span>.<span class="ident">set</span>[<span class="ident">i</span>];
                <span class="kw">if</span> <span class="self">self</span>.<span class="ident">step</span>(
                    <span class="kw-2">&amp;mut</span> <span class="ident">nlist</span>,
                    <span class="ident">matches</span>,
                    <span class="ident">slots</span>,
                    <span class="ident">clist</span>.<span class="ident">caps</span>(<span class="ident">ip</span>),
                    <span class="ident">ip</span>,
                    <span class="ident">at</span>,
                    <span class="ident">at_next</span>,
                ) {
                    <span class="ident">matched</span> <span class="op">=</span> <span class="bool-val">true</span>;
                    <span class="ident">all_matched</span> <span class="op">=</span> <span class="ident">all_matched</span> <span class="op">|</span><span class="op">|</span> <span class="ident">matches</span>.<span class="ident">iter</span>().<span class="ident">all</span>(<span class="op">|</span><span class="kw-2">&amp;</span><span class="ident">b</span><span class="op">|</span> <span class="ident">b</span>);
                    <span class="kw">if</span> <span class="ident">quit_after_match</span> {
                        <span class="comment">// If we only care if a match occurs (not its</span>
                        <span class="comment">// position), then we can quit right now.</span>
                        <span class="kw">break</span> <span class="lifetime">&#39;LOOP</span>;
                    }
                    <span class="kw">if</span> <span class="self">self</span>.<span class="ident">prog</span>.<span class="ident">matches</span>.<span class="ident">len</span>() <span class="op">==</span> <span class="number">1</span> {
                        <span class="comment">// We don&#39;t need to check the rest of the threads</span>
                        <span class="comment">// in this set because we&#39;ve matched something</span>
                        <span class="comment">// (&quot;leftmost-first&quot;). However, we still need to check</span>
                        <span class="comment">// threads in the next set to support things like</span>
                        <span class="comment">// greedy matching.</span>
                        <span class="comment">//</span>
                        <span class="comment">// This is only true on normal regexes. For regex sets,</span>
                        <span class="comment">// we need to mush on to observe other matches.</span>
                        <span class="kw">break</span>;
                    }
                }
            }
            <span class="kw">if</span> <span class="ident">at</span>.<span class="ident">pos</span>() <span class="op">&gt;</span><span class="op">=</span> <span class="ident">end</span> {
                <span class="kw">break</span>;
            }
            <span class="ident">at</span> <span class="op">=</span> <span class="ident">at_next</span>;
            <span class="ident">mem::swap</span>(<span class="ident">clist</span>, <span class="ident">nlist</span>);
            <span class="ident">nlist</span>.<span class="ident">set</span>.<span class="ident">clear</span>();
        }
        <span class="ident">matched</span>
    }

    <span class="doccomment">/// Step through the input, one token (byte or codepoint) at a time.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// nlist is the set of states that will be processed on the next token</span>
    <span class="doccomment">/// in the input.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// caps is the set of captures passed by the caller of the NFA. They are</span>
    <span class="doccomment">/// written to only when a match state is visited.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// thread_caps is the set of captures set for the current NFA state, ip.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// at and at_next are the current and next positions in the input. at or</span>
    <span class="doccomment">/// at_next may be EOF.</span>
    <span class="kw">fn</span> <span class="ident">step</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="ident">nlist</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Threads</span>,
        <span class="ident">matches</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">bool</span>],
        <span class="ident">slots</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">Slot</span>],
        <span class="ident">thread_caps</span>: <span class="kw-2">&amp;mut</span> [<span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>],
        <span class="ident">ip</span>: <span class="ident">usize</span>,
        <span class="ident">at</span>: <span class="ident">InputAt</span>,
        <span class="ident">at_next</span>: <span class="ident">InputAt</span>,
    ) -&gt; <span class="ident">bool</span> {
        <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::prog::Inst</span>::<span class="kw-2">*</span>;
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">prog</span>[<span class="ident">ip</span>] {
            <span class="ident">Match</span>(<span class="ident">match_slot</span>) =&gt; {
                <span class="kw">if</span> <span class="ident">match_slot</span> <span class="op">&lt;</span> <span class="ident">matches</span>.<span class="ident">len</span>() {
                    <span class="ident">matches</span>[<span class="ident">match_slot</span>] <span class="op">=</span> <span class="bool-val">true</span>;
                }
                <span class="kw">for</span> (<span class="ident">slot</span>, <span class="ident">val</span>) <span class="kw">in</span> <span class="ident">slots</span>.<span class="ident">iter_mut</span>().<span class="ident">zip</span>(<span class="ident">thread_caps</span>.<span class="ident">iter</span>()) {
                    <span class="kw-2">*</span><span class="ident">slot</span> <span class="op">=</span> <span class="kw-2">*</span><span class="ident">val</span>;
                }
                <span class="bool-val">true</span>
            }
            <span class="ident">Char</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) =&gt; {
                <span class="kw">if</span> <span class="ident">inst</span>.<span class="ident">c</span> <span class="op">==</span> <span class="ident">at</span>.<span class="ident">char</span>() {
                    <span class="self">self</span>.<span class="ident">add</span>(<span class="ident">nlist</span>, <span class="ident">thread_caps</span>, <span class="ident">inst</span>.<span class="ident">goto</span>, <span class="ident">at_next</span>);
                }
                <span class="bool-val">false</span>
            }
            <span class="ident">Ranges</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) =&gt; {
                <span class="kw">if</span> <span class="ident">inst</span>.<span class="ident">matches</span>(<span class="ident">at</span>.<span class="ident">char</span>()) {
                    <span class="self">self</span>.<span class="ident">add</span>(<span class="ident">nlist</span>, <span class="ident">thread_caps</span>, <span class="ident">inst</span>.<span class="ident">goto</span>, <span class="ident">at_next</span>);
                }
                <span class="bool-val">false</span>
            }
            <span class="ident">Bytes</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) =&gt; {
                <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">b</span>) <span class="op">=</span> <span class="ident">at</span>.<span class="ident">byte</span>() {
                    <span class="kw">if</span> <span class="ident">inst</span>.<span class="ident">matches</span>(<span class="ident">b</span>) {
                        <span class="self">self</span>.<span class="ident">add</span>(<span class="ident">nlist</span>, <span class="ident">thread_caps</span>, <span class="ident">inst</span>.<span class="ident">goto</span>, <span class="ident">at_next</span>);
                    }
                }
                <span class="bool-val">false</span>
            }
            <span class="ident">EmptyLook</span>(<span class="kw">_</span>) <span class="op">|</span> <span class="ident">Save</span>(<span class="kw">_</span>) <span class="op">|</span> <span class="ident">Split</span>(<span class="kw">_</span>) =&gt; <span class="bool-val">false</span>,
        }
    }

    <span class="doccomment">/// Follows epsilon transitions and adds them for processing to nlist,</span>
    <span class="doccomment">/// starting at and including ip.</span>
    <span class="kw">fn</span> <span class="ident">add</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="ident">nlist</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Threads</span>,
        <span class="ident">thread_caps</span>: <span class="kw-2">&amp;mut</span> [<span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>],
        <span class="ident">ip</span>: <span class="ident">usize</span>,
        <span class="ident">at</span>: <span class="ident">InputAt</span>,
    ) {
        <span class="self">self</span>.<span class="ident">stack</span>.<span class="ident">push</span>(<span class="ident">FollowEpsilon::IP</span>(<span class="ident">ip</span>));
        <span class="kw">while</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">frame</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">stack</span>.<span class="ident">pop</span>() {
            <span class="kw">match</span> <span class="ident">frame</span> {
                <span class="ident">FollowEpsilon::IP</span>(<span class="ident">ip</span>) =&gt; {
                    <span class="self">self</span>.<span class="ident">add_step</span>(<span class="ident">nlist</span>, <span class="ident">thread_caps</span>, <span class="ident">ip</span>, <span class="ident">at</span>);
                }
                <span class="ident">FollowEpsilon::Capture</span> { <span class="ident">slot</span>, <span class="ident">pos</span> } =&gt; {
                    <span class="ident">thread_caps</span>[<span class="ident">slot</span>] <span class="op">=</span> <span class="ident">pos</span>;
                }
            }
        }
    }

    <span class="doccomment">/// A helper function for add that avoids excessive pushing to the stack.</span>
    <span class="kw">fn</span> <span class="ident">add_step</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="ident">nlist</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Threads</span>,
        <span class="ident">thread_caps</span>: <span class="kw-2">&amp;mut</span> [<span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>],
        <span class="kw-2">mut</span> <span class="ident">ip</span>: <span class="ident">usize</span>,
        <span class="ident">at</span>: <span class="ident">InputAt</span>,
    ) {
        <span class="comment">// Instead of pushing and popping to the stack, we mutate ip as we</span>
        <span class="comment">// traverse the set of states. We only push to the stack when we</span>
        <span class="comment">// absolutely need recursion (restoring captures or following a</span>
        <span class="comment">// branch).</span>
        <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::prog::Inst</span>::<span class="kw-2">*</span>;
        <span class="kw">loop</span> {
            <span class="comment">// Don&#39;t visit states we&#39;ve already added.</span>
            <span class="kw">if</span> <span class="ident">nlist</span>.<span class="ident">set</span>.<span class="ident">contains</span>(<span class="ident">ip</span>) {
                <span class="kw">return</span>;
            }
            <span class="ident">nlist</span>.<span class="ident">set</span>.<span class="ident">insert</span>(<span class="ident">ip</span>);
            <span class="kw">match</span> <span class="self">self</span>.<span class="ident">prog</span>[<span class="ident">ip</span>] {
                <span class="ident">EmptyLook</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) =&gt; {
                    <span class="kw">if</span> <span class="self">self</span>.<span class="ident">input</span>.<span class="ident">is_empty_match</span>(<span class="ident">at</span>, <span class="ident">inst</span>) {
                        <span class="ident">ip</span> <span class="op">=</span> <span class="ident">inst</span>.<span class="ident">goto</span>;
                    }
                }
                <span class="ident">Save</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) =&gt; {
                    <span class="kw">if</span> <span class="ident">inst</span>.<span class="ident">slot</span> <span class="op">&lt;</span> <span class="ident">thread_caps</span>.<span class="ident">len</span>() {
                        <span class="self">self</span>.<span class="ident">stack</span>.<span class="ident">push</span>(<span class="ident">FollowEpsilon::Capture</span> {
                            <span class="ident">slot</span>: <span class="ident">inst</span>.<span class="ident">slot</span>,
                            <span class="ident">pos</span>: <span class="ident">thread_caps</span>[<span class="ident">inst</span>.<span class="ident">slot</span>],
                        });
                        <span class="ident">thread_caps</span>[<span class="ident">inst</span>.<span class="ident">slot</span>] <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">at</span>.<span class="ident">pos</span>());
                    }
                    <span class="ident">ip</span> <span class="op">=</span> <span class="ident">inst</span>.<span class="ident">goto</span>;
                }
                <span class="ident">Split</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) =&gt; {
                    <span class="self">self</span>.<span class="ident">stack</span>.<span class="ident">push</span>(<span class="ident">FollowEpsilon::IP</span>(<span class="ident">inst</span>.<span class="ident">goto2</span>));
                    <span class="ident">ip</span> <span class="op">=</span> <span class="ident">inst</span>.<span class="ident">goto1</span>;
                }
                <span class="ident">Match</span>(<span class="kw">_</span>) <span class="op">|</span> <span class="ident">Char</span>(<span class="kw">_</span>) <span class="op">|</span> <span class="ident">Ranges</span>(<span class="kw">_</span>) <span class="op">|</span> <span class="ident">Bytes</span>(<span class="kw">_</span>) =&gt; {
                    <span class="kw">let</span> <span class="ident">t</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">nlist</span>.<span class="ident">caps</span>(<span class="ident">ip</span>);
                    <span class="kw">for</span> (<span class="ident">slot</span>, <span class="ident">val</span>) <span class="kw">in</span> <span class="ident">t</span>.<span class="ident">iter_mut</span>().<span class="ident">zip</span>(<span class="ident">thread_caps</span>.<span class="ident">iter</span>()) {
                        <span class="kw-2">*</span><span class="ident">slot</span> <span class="op">=</span> <span class="kw-2">*</span><span class="ident">val</span>;
                    }
                    <span class="kw">return</span>;
                }
            }
        }
    }
}

<span class="kw">impl</span> <span class="ident">Threads</span> {
    <span class="kw">fn</span> <span class="ident">new</span>() -&gt; <span class="self">Self</span> {
        <span class="ident">Threads</span> { <span class="ident">set</span>: <span class="ident">SparseSet::new</span>(<span class="number">0</span>), <span class="ident">caps</span>: <span class="macro">vec!</span>[], <span class="ident">slots_per_thread</span>: <span class="number">0</span> }
    }

    <span class="kw">fn</span> <span class="ident">resize</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">num_insts</span>: <span class="ident">usize</span>, <span class="ident">ncaps</span>: <span class="ident">usize</span>) {
        <span class="kw">if</span> <span class="ident">num_insts</span> <span class="op">==</span> <span class="self">self</span>.<span class="ident">set</span>.<span class="ident">capacity</span>() {
            <span class="kw">return</span>;
        }
        <span class="self">self</span>.<span class="ident">slots_per_thread</span> <span class="op">=</span> <span class="ident">ncaps</span> <span class="op">*</span> <span class="number">2</span>;
        <span class="self">self</span>.<span class="ident">set</span> <span class="op">=</span> <span class="ident">SparseSet::new</span>(<span class="ident">num_insts</span>);
        <span class="self">self</span>.<span class="ident">caps</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="prelude-val">None</span>; <span class="self">self</span>.<span class="ident">slots_per_thread</span> <span class="op">*</span> <span class="ident">num_insts</span>];
    }

    <span class="kw">fn</span> <span class="ident">caps</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">pc</span>: <span class="ident">usize</span>) -&gt; <span class="kw-2">&amp;mut</span> [<span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>] {
        <span class="kw">let</span> <span class="ident">i</span> <span class="op">=</span> <span class="ident">pc</span> <span class="op">*</span> <span class="self">self</span>.<span class="ident">slots_per_thread</span>;
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>.<span class="ident">caps</span>[<span class="ident">i</span>..<span class="ident">i</span> <span class="op">+</span> <span class="self">self</span>.<span class="ident">slots_per_thread</span>]
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="regex" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>